// Created by John Liaperdos and George Theophanous, July 2015

var R_val=1000; // in Ω
var C_val=1000; // in nF
var C_multiplier=1;
var frequency_val=1000; // in Hz
var Vp=80;

function refreshData(action_code){ 
	if (action_code==2)
	{
		if(frequency_val<5000)
		{
			frequency_val=frequency_val+1000;
		}				
	};
	if (action_code==1)
	{
		if(frequency_val>1000)
		{
			frequency_val=frequency_val-1000;
		}		
	};
	if (action_code==4)
	{
		R_val=R_val+1000;	
	};
	if (action_code==3)
	{
		if(R_val>1000)
		{
			R_val=R_val-1000;
		}		
	};
	if (action_code==6)
	{
		C_val=C_val+1000;	
	};
	if (action_code==5)
	{
		if(C_val>1000)
		{
			C_val=C_val-1000;
		}		
	};	
	document.getElementById('frequency_text').innerHTML='f='+frequency_val/1000+'kHz';
	document.getElementById('resistance_text').innerHTML='R='+R_val/1000+'kΩ';
	document.getElementById('capacitance_text').innerHTML='C='+C_val/1000;
	refreshPlots();
}	

function refreshPlots() {
	C_multiplier=1/Math.pow(1000,document.getElementById('capacitance_units').selectedIndex);
	if(C_multiplier!=1 && C_val<50000)
	{
		C_val=50000;
		document.getElementById('capacitance_text').innerHTML='C=50';
	}

	var svg = document.getElementById('interactive_01').children[0];
	var origin = { //origin of axes
		x: 0,
		y: 100
	};
	var amplitude_in = -Vp; // wave amplitude
	var rarity_in = 2; // point spacing
	var freq_in = frequency_val/10000; // angular frequency
	var period_in_milliseconds=2*3.14*1000/frequency_val;
	var period_in_points=10*period_in_milliseconds; 
	var rarity_out = 2; // point spacing
	
	// clear figure
		while (svg.hasChildNodes()) {
			svg.removeChild(svg.lastChild);
		}
	
	// draw axes
		var axis1 = document.createElementNS("http://www.w3.org/2000/svg", "line");
		axis1.setAttribute('x1', '0');
		axis1.setAttribute('y1', '-10');
		axis1.setAttribute('x2', '0');
		axis1.setAttribute('y2', '100');
		axis1.setAttribute('style', 'stroke:black;stroke-width:1');
		svg.appendChild(axis1);
		var axis2 = document.createElementNS("http://www.w3.org/2000/svg", "line");
		axis2.setAttribute('x1', '0');
		axis2.setAttribute('y1', '100');
		axis2.setAttribute('x2', '300');
		axis2.setAttribute('y2', '100');
		axis2.setAttribute('style', 'stroke:black;stroke-width:1');
		svg.appendChild(axis2);	
		var text_V = document.createElementNS("http://www.w3.org/2000/svg", "text");
		text_V.setAttribute('x', '-10');
		text_V.setAttribute('y', '-5');
		text_V.setAttribute('text-anchor', 'end');
		text_V.textContent ='V';
		svg.appendChild(text_V);
		var text_t = document.createElementNS("http://www.w3.org/2000/svg", "text");
		text_t.setAttribute('x', '300');
		text_t.setAttribute('y', '120');
		text_t.setAttribute('text-anchor', 'end');
		text_t.textContent ='t';
		svg.appendChild(text_t);
		
	for (var i = 1; i <= 150; i++) {
		current_period=Math.ceil(i/period_in_points);
		var line_in = document.createElementNS("http://www.w3.org/2000/svg", "line");

		line_in.setAttribute('id', 'svg_line_in');
		line_in.setAttribute('x1', (i - 1) * rarity_in + origin.x);
		sine_val=Math.sin(freq_in * (i - 1)) * amplitude_in;

		sine_val=sine_val+origin.y;
		line_in.setAttribute('y1', Math.min(origin.y,sine_val));

		sine_val=Math.sin(freq_in * i) * amplitude_in;

		sine_val=sine_val+origin.y;
		
		line_in.setAttribute('x2', i * rarity_in + origin.x);
		line_in.setAttribute('y2', Math.min(origin.y,sine_val));

		line_in.setAttribute('style', "stroke:blue;stroke-width:2");  

		svg.appendChild(line_in);
	}

	for (var i = 1; i <= 150; i++) {
		current_period=Math.ceil(i/period_in_points);	
		var line_out = document.createElementNS("http://www.w3.org/2000/svg", "line");

		line_out.setAttribute('id', 'svg_line_out');
		line_out.setAttribute('x1', (i - 1+0.25*period_in_points) * rarity_out + origin.x);
		
		sine_val=Math.max(0,-Math.sin(freq_in * (i - 1+0.25*period_in_points)) * amplitude_in);	
		
		discharge_val=amplitude_in*Math.exp(-(i-1-(current_period-1)*period_in_points)/(R_val*C_val*C_multiplier*1e-3));
		
		y_val=Math.max(sine_val,-discharge_val);

		line_out.setAttribute('y1', -y_val+origin.y);

		sine_val=Math.max(0,-Math.sin(freq_in * (i +0.25*period_in_points)) * amplitude_in);	
		discharge_val=amplitude_in*Math.exp(-(i-(current_period-1)*period_in_points)/(R_val*C_val*C_multiplier*1e-3));
		y_val=Math.max(sine_val,-discharge_val);

		line_out.setAttribute('x2', (i+0.25*period_in_points) * rarity_out + origin.x);
		line_out.setAttribute('y2', -y_val + origin.y);

		line_out.setAttribute('style', "stroke:magenta;stroke-width:2");    

		svg.appendChild(line_out);
	}	
}